<?php
//
//  Nagios Core Config Manager
//  Copyright (c) 2010-2015 Nagios Enterprises, LLC
//
//  Nagios XI-only splash homepage
//

require_once(dirname(__FILE__) . '/../../common.inc.php');

global $ccmDB;
global $lstr;

// Get object xml
$html = "";
$hargs = array('brevity' => 1, 'orderby' => 'host_name:a');
$sargs = array('brevity' => 1, 'orderby' => 'service_description:a');
$hgargs = array('orderby' => 'hostgroup_name:a');
$sgargs = array('orderby' => 'servicegroup_name:a');

// Second row
$caargs = array('orderby' => 'contact_name:a', 'contact_name' => 'ne:xi_default_contact');
$cggargs = array('orderby' => 'contactgroup_name:a');
$hdargs = array('orderby' => 'servicegroup_name:a');
$sdargs = array('orderby' => 'servicegroup_name:a');

///////////////////////////////
// get object xml to display //

$hxml = get_xml_host_objects($hargs);
if ($hxml) {
    $host_count = strval($hxml->recordcount);
}
$sxml = get_xml_service_objects($sargs);
if ($sxml) {
    $service_count = strval($sxml->recordcount);
}
$hgxml = get_xml_hostgroup_objects($hgargs);
if ($hgxml) {
    $hostgroup_count = strval($hgxml->recordcount);
}
$sgxml = get_xml_servicegroup_objects($sgargs);
if ($sgxml) {
    $servicegroup_count = strval($sgxml->recordcount);
}
// find number of commands
$command_count = 0;
$command_sql = $ccmDB->query("SELECT COUNT(*) FROM tbl_command;");
$command_count = $command_sql[0]["COUNT(*)"];

// second row xml display
$caxml = get_xml_contact_objects($caargs);
if ($caxml) {
    $contact_count = strval($caxml->recordcount);
}
$cgxml = get_xml_contactgroup_objects($cggargs);
if ($cgxml) {
    $contactgroup_count = strval($cgxml->recordcount);
}
$hdxml = get_xml_servicegroup_objects($hdargs);
if ($hdxml) {
    $hostdependency_count = strval($hdxml->recordcount);
}
$sdxml = get_xml_servicegroup_objects($sdargs);
if ($sdxml) {
    $servicedependency_count = strval($sdxml->recordcount);
}

// Retrieve data for recent changes table
$host_change_sql = $ccmDB->query("SELECT * FROM `tbl_host` WHERE `config_id`=1 ORDER BY `last_modified` DESC LIMIT 5");
$service_change_sql = $ccmDB->query("SELECT * FROM `tbl_service` WHERE `config_id`=1 ORDER BY `last_modified` DESC LIMIT 5");
$host_change_sql_na = $ccmDB->query("SELECT * FROM `tbl_host` WHERE `active`=0 ORDER BY `last_modified` DESC LIMIT 5");
$service_change_sql_na = $ccmDB->query("SELECT * FROM `tbl_service` WHERE `active`=0 ORDER BY `last_modified` DESC LIMIT 5");

// snapshots function for recent table
$snapshots = get_nagioscore_config_snapshots();
// end xml section //
/////////////////////

// Show config status icon
$config_status = "";
$ac_needed = get_option("ccm_apply_config_needed", 0);
if ($ac_needed == 0) {
    $config_status = "
        <div class='ccm-top-ok'>
            " . _("Configuration Status") . ": <i class='fa fa-check-square-o ccm-icon-style'></i>&nbsp;OK&nbsp; <span style='font-size:16px;color:#000;'>|</span> &nbsp;
            <a class='btn btn-sm btn-primary' style='font-size:10px;color:#fff;' href='/nagiosxi/includes/components/ccm/index.php?cmd=apply&type=verify'><i class='fa fa-cogs ccm-icon-style'></i> "._("Verify Configuration")."</a>
        </div>";
} else {
    $config_status = "
        <div class='ccm-top-danger'>
            " . _("Configuration Status") . ": <i class='fa fa-asterisk urgent'></i>&nbsp;Configuration not applied!&nbsp;
            <a class='btn btn-sm btn-primary' style='font-size:10px;color:#fff;' href='/nagiosxi/includes/components/nagioscorecfg/applyconfig.php'><i class='fa fa-download ccm-icon-style'></i> "._("Apply Configuration")."</a>
        </div>";
}

// $sql = $ccmDB->query("SELECT * FROM tbl_host;");
// foreach ($sql as $a) {
//     print "<pre>";
//     print_r($a["active"]);
//     print "</pre>";
// }

// create sunburst
$html = "

<div id='contentWrapper' class='ccm-splash-wrapper'>
    <div class='ccm-top'>
        <div>
            <img src='" . get_base_url() . "includes/components/ccm/images/ccm.png'><span style='color:#4D89F9;font-family: arial; font-weight: bold; font-size: 20px; vertical-align: middle;'> v" . CCMVERSION . "</span> &nbsp;
        </div>
        <div style='text-align:center;'>
            <span style='overflow:hidden;'>" . $config_status . "</span>
        </div>
    </div>
    <div class='ccm-splash-main'>
        <div class='ccm-table-inherit'>
            <div class='ccm-table-interit-container'>
                <div class='ccm-table-interit-cell'>
                    <div class='row-fluid ccm-table-header'>
                        <div class='ccm-table-title'><i class='fa fa-bar-chart'></i>&nbsp;&nbsp;<span>Nagios XI Summary</span></div>
                        <div class='clearfix'></div>
                    </div>
                    <br>
                    <div style='display:inline-block;margin-left: 10px;text-align: left;'>
                        <span style='font-size:12px;'>" . _("Click on an item to view it in more detail.") . "</span>
                    </div>
                    <div class='ccm-table-data'>
                        <div class='clearfix'></div>
                        <div class='grid-content overflow'>
                            <div class='row-fluid center-table'>
                                <div class='ccm-stat-box-large'>
                                    <a href='" . get_base_url() . "includes/components/ccm/?cmd=view&type=host'>
                                        <div class='ccm-stat-box btn btn-lg btn-primary'>
                                            <i class='fa fa-desktop fa-fw ccm-icon-style'></i><span class='ccm-stat-detail'>" . $host_count . "</span><span class='ccm-stat-text'>" . _("Hosts") .  "</span>
                                            
                                        </div>
                                    </a>
                                </div>
                                <div class='ccm-stat-box-large'>
                                    <a href='" . get_base_url() . "includes/components/ccm/?cmd=view&type=service'>
                                        <div class='ccm-stat-box btn btn-lg btn-primary'>
                                            <i class='fa fa-cube fa-fw ccm-icon-style'></i><span class='ccm-stat-detail'>" . $service_count . "</span><span class='ccm-stat-text'>" . _("Services") . "</span>
                                            
                                        </div>
                                    </a>
                                </div>
                                <div class='ccm-stat-box-large'>
                                    <a href='" . get_base_url() . "includes/components/ccm/?cmd=view&type=hostgroup'>
                                        <div class='ccm-stat-box btn btn-lg btn-primary'>
                                            <i class='fa fa-desktop fa-fw ccm-icon-style'></i><span class='ccm-stat-detail'>" . $hostgroup_count . "</span><span class='ccm-stat-text'>" . _("Host Groups") . "</span>
                                            
                                        </div>
                                    </a>
                                </div>
                                <div class='ccm-stat-box-large'>
                                    <a href='" . get_base_url() . "includes/components/ccm/?cmd=view&type=servicegroup'>
                                        <div class='ccm-stat-box btn btn-lg btn-primary'>
                                            <i class='fa fa-cubes fa-fw ccm-icon-style'></i><span class='ccm-stat-detail'>" . $servicegroup_count . "</span><span class='ccm-stat-text'>" . _("Service Groups") . "</span>
                                            
                                        </div>
                                    </a>
                                </div>

                                <div class='ccm-stat-box-large'>
                                    <a href='" . get_base_url() . "includes/components/ccm/?cmd=view&type=contact'>
                                        <div class='ccm-stat-box btn btn-lg btn-primary'>
                                            <i class='fa fa-user fa-fw ccm-icon-style'></i><span class='ccm-stat-detail'>" . $contact_count . "</span><span class='ccm-stat-text'>" . _("Contacts") . "</span>
                                            
                                        </div>
                                    </a>
                                </div>
                                <div class='ccm-stat-box-large'>
                                    <a href='" . get_base_url() . "includes/components/ccm/?cmd=view&type=contactgroup'>
                                        <div class='ccm-stat-box btn btn-lg btn-primary'>
                                            <i class='fa fa-users fa-fw ccm-icon-style'></i><span class='ccm-stat-detail'>" . $contactgroup_count . "</span><span class='ccm-stat-text'>" . _("Contact Groups") . "</span>
                                            
                                        </div>
                                    </a>
                                </div>
                                <div class='ccm-stat-box-large'>
                                    <a href='" . get_base_url() . "includes/components/ccm/?cmd=view&type=command'>
                                        <div class='ccm-stat-box btn btn-lg btn-primary'>
                                            <i class='fa fa-keyboard-o fa-fw ccm-icon-style'></i><span class='ccm-stat-detail'>" . $command_count . "</span><span class='ccm-stat-text'>" . _("Commands") . "</span>
                                            
                                        </div>
                                    </a>
                                </div>
                                <div class='ccm-stat-box-large'>
                                    <a href='" . get_base_url() . "includes/components/ccm/?cmd=view&type=hostdependency'>
                                        <div class='ccm-stat-box btn btn-lg btn-primary'>
                                            <i class='fa fa-sitemap fa-fw ccm-icon-style'></i><span class='ccm-stat-detail'>" . $hostdependency_count . "</span><span class='ccm-stat-text'>" . _("Host Dependencies") . "</span>
                                            
                                        </div>
                                    </a>
                                </div>
                                <div class='ccm-stat-box-large'>
                                    <a href='" . get_base_url() . "includes/components/ccm/?cmd=view&type=servicedependency'>
                                        <div class='ccm-stat-box btn btn-lg btn-primary'>
                                            <i class='fa fa-sitemap fa-fw ccm-icon-style'></i><span class='ccm-stat-detail'>" . $servicedependency_count . "</span><span class='ccm-stat-text'>" . _("Service Dependencies") . "</span>
                                            
                                        </div>
                                    </a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class='ccm-table-interit-cell'>
                    <div class='ccm-table-block'>
                        <div class='row-fluid ccm-table-header'>
                            <div class='ccm-table-title'><i class='fa fa-gears'></i>&nbsp;&nbsp;<span>Recently Changed Hosts and Services</span></div><br>
                            <div class='clearfix'></div>
                        </div>
                        <br>
                        <div class='row-fluid center-table'>
                            <div style='display:inline-block;margin-left: 10px;text-align: left;'>
                                <span style='font-size:12px;font-weight:bold;'>" . _("Hosts") . "</span>
                            </div>
                            <table class='table table-condensed table-bordered table-striped ccm-table-center'>
                                <thead>
                                <tr>
                                    <th class='ccm-table-adjust-1'>" . _("Host Name") . "</th>
                                    <th>" . _("Modified Time") . "</th>
                                </tr>
                                </thead>
                                <tbody>";
                                // applied changes - host
                                // we have data? make table
                                if ($host_change_sql) {
                                    $x = 0;

                                    foreach ($host_change_sql as $a) {
                                        $x++;
                                        if ($x > 5)
                                            break;

                                        $html .= "<tr>";
                                        $html .= "<td class='ccm-table-adjust-1'><a href='" . get_base_url() . "includes/components/ccm/?cmd=modify&type=host&id=" . $a['id'] . "&page=1'>" . $a['host_name'] . "</a></td>";
                                        $html .= "<td nowrap><span class='notificationtime'>" . $a['last_modified'] . "</span></td>";
                                        $html .= "</tr>";
                                    }
                                } else {
                                    $html .= "<tr><td colspan='7'>" . _("No matching results found.") . "</td></tr>\n";
                                } // end changes table
                            $html .="
                                </tbody>
                            </table>
                            <div style='display:inline-block;margin-left: 10px;text-align: left;'>
                                <span style='font-size:12px;font-weight:bold;'>" . _("Services") . "</span>
                            </div>
                            <table class='table table-condensed table-bordered table-striped ccm-table-center'>
                                <thead>
                                <tr>
                                    <th>" . _("Config Name") . "</th>
                                    <th>" . _("Service Name") . "</th>
                                    <th>" . _("Modified Time") . "</th>
                                </tr>
                                </thead>
                                <tbody>";
                                // applied changes - service
                                // we have data? make table
                                if ($service_change_sql) {
                                    $x = 0;

                                    foreach ($service_change_sql as $a) {
                                        $x++;
                                        if ($x > 5)
                                            break;

                                        $html .= "<tr>";
                                        $html .= "<td><a href='" . get_base_url() . "includes/components/ccm/?cmd=view&type=service&search=&name_filter=" . $a['config_name'] . "&page=1'>" . $a['config_name'] . "</a></td>";
                                        $html .= "<td><a href='" . get_base_url() . "includes/components/ccm/?cmd=modify&type=service&id=" . $a['id'] . "&page=1'>" . $a['service_description'] . "</a></td>";
                                        $html .= "<td nowrap><span class='notificationtime'>" . $a['last_modified'] . "</span></td>";
                                        $html .= "</tr>";
                                    }
                                } else {
                                    $html .= "<tr><td colspan='7'>" . _("No matching results found.") . "</td></tr>\n";
                                } // end changes table
                            $html .="
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
                <div class='ccm-table-interit-cell'>
                    <div class='ccm-table-block'>
                        <div class='row-fluid ccm-table-header'>
                            <div class='ccm-table-title'><i class='fa fa-gear'></i>&nbsp;&nbsp;Recent Snapshots</div><br>
                            <div class='clearfix'></div>
                        </div>
                        <div class='row-fluid center-table'>
                            <div style='margin: 10px;text-align: left;'>
                                <span><a href='" . get_base_url() . "admin/coreconfigsnapshots.php'>" . _('Monitor Snapshots >') . "</a></span>
                            </div>
                            <div style='margin: 10px 0 0 10px;text-align: left;'>
                                <div style='font-weight:bold;'>" . _("12 most recent snapshots") . "</div>
                            </div>
                            <table class='table table-bordered table-striped ccm-table-center'>
                                <thead>
                                <tr>
                                    <th>" . _("Date") . "</th>
                                    <th>" . _("Snapshot Result") . "</th>
                                    <th>" . _("Actions") . "</th>
                                </tr>
                                </thead>
                                <tbody>";
                                // fill snapshot table
                                $x = 0;
                                $y = 0;
                                $archives = 0;
                                foreach ($snapshots as $snapshot) {

                                    if ($snapshot["archive"]) {
                                        $archives++;
                                        continue;
                                    }                                    

                                    $resultstring = "Config Ok";
                                    $rowclass = "";
                                    $qstring = "result=ok&archive=0";
                                    if ($snapshot["error"] == true) {
                                        $resultstring = "Config Error";
                                        $rowclass = "ccm-alert";
                                        $qstring = "result=error&archive=0";
                                    }

                                    if ($resultstring == "Config Ok") {
                                        $x++;
                                    } else {
                                        $y++;
                                    }

                                    if (($x + $y) > 12)
                                        break;

                                    $html .= "<tr class=" . $rowclass . ">";
                                    $html .= "<td nowrap>" . $snapshot["date"] . "</td>";
                                    $html .= "<td>" . $resultstring . "</td>";
                                    $html .= "<td nowrap>";
                                    $html .= "<a href='" . get_base_url() . "admin/coreconfigsnapshots.php?download=" . $snapshot["timestamp"] . "&" . $qstring . "'><img src='".theme_image('package_go.png')."' class='tt-bind' title='"._('Download')."'></a> ";
                                    $html .= "<a href='" . get_base_url() . "admin/coreconfigsnapshots.php?view=" . $snapshot["timestamp"] . "&" . $qstring . "'><img src='".theme_image('page_white.png')."' class='tt-bind' title='"._('View')."'></a> ";
                                    if ($snapshot["error"] == true) {
                                        $html .= "<a href='" . get_base_url() . "admin/coreconfigsnapshots.php?delete=" . $snapshot["timestamp"] . "&" . $qstring . "'><img src='".theme_image('cross.png')."' class='tt-bind' title='"._('Delete')."'></a> ";
                                    } else {
                                        if (use_2012_features() == true)
                                            $html .= "<a href='" . get_base_url() . "admin/coreconfigsnapshots.php?restore=" . $snapshot["timestamp"] . "&" . $qstring . "'><img src='".theme_image('arrow_undo.png')."' class='tt-bind' title='"._('Restore')."'></a> ";
                                        if (use_2014_features() == true)
                                            $html .= "<a href='" . get_base_url() . "admin/coreconfigsnapshots.php?doarchive=" . $snapshot["timestamp"] . "&" . $qstring . "'><img src='".theme_image('folder_go.png')."' class='tt-bind' title='"._('Archive')."'></a>";
                                    }
                                    $html .= "</td>";
                                    $html .= "</tr>";
                                }
                            $html .= "
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <p style='float:left;vertical-align: top;'>" . _("Nagios CCM is based on NagiosQL 3.0.3") . "</p>
        </div>
        <div class='ccm-push'></div>
    </div>
    <div class='ccm-foot'>
        <div class='ccm-foot-box'>
            <div class='ccm-foot-toolbox'>
                <div class='ccm-foot-quarter'>
                    <a href='" . get_base_url() . "config/monitoringwizard.php'><i class='fa fa-desktop fa-2x'></i><br>Config Wizards</a>
                </div>
                <div class='ccm-foot-quarter'>
                    <a href='http://support.nagios.com/' target='_blank'><i class='fa fa-wrench fa-2x'></i><br>Nagios Support</a>
                </div>
            </div>
        </div>
    </div>
</div>";