#!/bin/sh
# Copyright (c) 2008-2015 Nagios Enterprises, LLC.  All rights reserved.
# $Id: nom_create_nagioscore_errorpoint.sh 3376 2015-05-08 15:28:20Z swilkerson $

BASEDIR=$(dirname $(readlink -f $0))

# IMPORT ALL XI CFG VARS
php $BASEDIR/import_xiconfig.php > $BASEDIR/config.dat
. $BASEDIR/config.dat
rm -rf $BASEDIR/config.dat
. $BASEDIR/../var/xi-sys.cfg

cfgdir="/usr/local/nagios/etc"
checkpointdir="/usr/local/nagiosxi/nom/checkpoints/nagioscore/errors"

pushd $checkpointdir

# What timestamp should we use for this files?
stamp=`date +%s`

# Get Nagios verification output
output=`/usr/local/nagios/bin/nagios -v /usr/local/nagios/etc/nagios.cfg > $stamp.txt`

# Create the tarball
tar czf $stamp.tar.gz $cfgdir

# Fix perms (if script run by root)
chown $nagiosuser:$nagiosgroup $stamp.txt
chown $nagiosuser:$nagiosgroup $stamp.tar.gz

popd
